<template>
  <div class="subscriptions-validity">
    <ob-radio
        v-for="item in period"
        :key="item.value"
        :label="item.title"
        v-model="selectedPeriod"
        :valueInput="item.value"
        class="subscriptions-validity-radio"
        @change="changePeriod"
    />
    <div
      v-if="selectedPeriod === 'for_period' && updatedSubscription.activeFromDate"
      class="subscriptions-validity-period"
    >
      с
      <ob-date-picker-constructor
        label=""
        v-model="activeFromDate"
        class="subscriptions-validity-period__field"
        @input="changeDate"
      />
      по
      <ob-date-picker-constructor
        label=""
        v-model="activeToDate"
        :sinceTo="[
          {
            from: new Date(1976, 0, 0),
            to: activeFromDate
          }
        ]"
        :is-valid-date="isActiveToDateValid"
        :blockTimeDateBefore="activeFromDate"
        class="subscriptions-validity-period__field"
        block-days-before-today
        @input="changeDate"
      />
    </div>
  </div>
</template>

<script>
  import ObRadio from 'common-components/src/obComponents/obRadio';
  import ObDatePickerConstructor from 'common-components/src/obComponents/obDatePickerConstructor';
  import cloneDeep from 'clone-deep';
  import moment from 'moment';

  export default {
    name: 'validity',
    components: {
      ObRadio,
      ObDatePickerConstructor
    },
    props: {
      subscription: {
        type: Object,
        default: () => {}
      }
    },
    data() {
      return {
        selectedPeriod: 'indefinitely',
        period: [
          {
            title: 'Бессрочно',
            value: 'indefinitely'
          },
          {
            title: 'На период',
            value: 'for_period'
          }
        ],
        updatedSubscription: null,
      }
    },
    mounted () {
      this.updatedSubscription = cloneDeep(this.subscription)

      if (this.updatedSubscription.activeToDate) {
        this.selectedPeriod = 'for_period'
      }
    },
    computed: {
      activeFromDate: {
        get() {
          return this.updatedSubscription.activeFromDate
        },
        set(val) {
          this.updatedSubscription.activeFromDate = moment(val).format('YYYY-MM-DD')
        }
      },
      activeToDate: {
        get() {
          return this.updatedSubscription.activeToDate
        },
        set(val) {
          this.updatedSubscription.activeToDate = moment(val).format('YYYY-MM-DD')
        }
      },
      isActiveToDateValid() {
        return moment(this.activeToDate).isAfter(this.activeFromDate)
      }
    },
    methods: {
      changePeriod (period) {
        if (!this.isActiveToDateValid) return
        if (period === 'indefinitely') {
          this.updatedSubscription.activeToDate = null;
          this.changeDate();
        }
      },
      changeDate () {
        if (!this.isActiveToDateValid) return
        this.$emit('setDate', {
          activeFromDate: moment(this.activeFromDate).format('YYYY-MM-DD'),
          activeToDate: this.activeToDate ? moment(this.activeToDate).format('YYYY-MM-DD') : null,
          subscription: this.subscription,
        });
      }
    },
  };
</script>

<style scoped lang="scss">
  .subscriptions-validity {
    padding: 0 5px;
    display: flex;
    align-items: center;
    &-radio {
      margin-right: 14px;
    }
    &-period {
      display: flex;
      align-items: center;
      &__field {
        margin: 0 8px;
      }
    }
  }
</style>